// ێNX

#ifndef IG_MODULE_CLASS_ROPE_AS
#define IG_MODULE_CLASS_ROPE_AS

// @ TCY(mUnitSize)Unitobt@ɏA
// @	̔z(mList)ێB
// @ ǉmێɁA̕𕡎ʂKvSȂB
// @ ejbǵu0I[vł͂ȂB

// @ ǂ܂ŒȂ邩킩ȂƂɎgB
// @ ɏꍇ́Aꂾ߂mۂĂǂB

// @ x`}[ŇʁAMCLongString xƂB

#module MCRope mList, mIdx, mUnitFill, mUnitSize

#define BufSize_Default 2048		// 1jbg̃TCY̊l

#define mCntUnits (mIdx + 1)						// jbg
#define mCurUnit  mList(mIdx)						// jbg
#define mCapacity (mUnitSize - mUnitFill)			// eTCY
#define mStrlen   ((mIdx * mUnitSize) + mUnitFill)	// ̑S

// o֐̎sāAmUnitFill  [0, mUnitSize] ̒lB
#define CheckUnitFillCondition assert (0 <= mUnitFill && mUnitFill <= mUnitSize)

//##########################################################
//        \zE
//##########################################################
//------------------------------------------------
// [i] \z
// 
// @prm unitlen : jbgɏ߂镶 (0ȉ => lA63ȉ => 63)
//------------------------------------------------
#define global Rope_new(%1, %2 = 0) newmod %1, MCRope@, %2
#modinit int _unitlen
	if ( _unitlen <= 0 ) {
		mUnitSize = BufSize_Default
	} else {
#ifdef _DEBUG
		mUnitSize = _unitlen
#else
		mUnitSize = limit(_unitlen, 64, 0xFFFF)
#endif
	}
	
	sdim mList, mUnitSize, 1
	Rope_clear thismod
	return
	
//------------------------------------------------
// [i] 
//------------------------------------------------
#define global Rope_delete(%1) delmod %1

//##########################################################
//        J\bh
//##########################################################
//------------------------------------------------
// ݒ肷
//------------------------------------------------
#modfunc Rope_set str string
	Rope_clear thismod
	Rope_add   thismod, string
	return
	
//------------------------------------------------
// ɒǉ
//------------------------------------------------
#modfunc Rope_add str _src, int _len
	tmpSrc = _src
	Rope_addv thismod, tmpSrc, _len
	return

#modfunc Rope_addv var src, int _len
	//,  local len, local idxSrc
	if ( _len ) { tmpLen = _len } else { tmpLen = strlen(src) }
	idxSrc = 0
	
	repeat
		// jbg܂Ă => Vjbgm
		if ( mCapacity <= 0 ) {
			Rope_allocUnit thismod
		}
		
		// jbgɎ܂Ȃ => 邾Ajbgg؂
		if ( mCapacity < (tmpLen - idxSrc) ) {
			memcpy mCurUnit, src, mCapacity, mUnitFill, idxSrc
			idxSrc    += mCapacity
			mUnitFill += mCapacity
			assert (mUnitFill == mUnitSize)
			
		// ܂ => 
		} else {
			if ( idxSrc ) {
			//	poke mCurUnit, mUnitFill, strmid(src, idxSrc, (len - idxSrc))
				memcpy mCurUnit, src, (tmpLen - idxSrc), mUnitFill, idxSrc
				mUnitFill += (tmpLen - idxSrc)
			} else {
			//	poke mCurUnit, mUnitFill, src
				memcpy mCurUnit, src, tmpLen, mUnitFill
				mUnitFill += tmpLen
			}
			break
		}
	loop
	
	CheckUnitFillCondition
	return
	
#define global Rope_cat       Rope_add
#define global Rope_push_back Rope_add

//------------------------------------------------
// A
//------------------------------------------------
#modfunc Rope_addchar int c
	
	// jbg܂Ă
	if ( mCapacity <= 0 ) { Rope_allocUnit thismod }
	
	poke mCurUnit, mUnitFill, c
	mUnitFill ++
	return
	
//------------------------------------------------
// 납
//------------------------------------------------
#modfunc Rope_erase_back int _size,  local size
	if ( _size <= 0 ) { return }
	
	if ( _size >= mStrlen ) {			// S
		mIdx = 0 : mUnitFill = 0
		return
	}
	
	size = _size
	
	// jbgŎ܂ꍇ
	if ( size <= mUnitFill ) {
		mUnitFill -= size
		
	// ܂Ȃꍇ
	} else {
		// jbg폜
		size -= mUnitFill
		mIdx --
		
		repeat ( size / mUnitSize )
#ifdef _DEBUG
			mCurUnit = "@@@@@"
#endif
			mIdx --
		loop
		
		mUnitFill = mUnitSize - ( size \ mUnitSize )	// c镶
	}
	
	CheckUnitFillCondition
	return
	
//------------------------------------------------
// ϐobt@ɕʂ
//------------------------------------------------
#modfunc Rope_tobuf var buf
	if ( vartype( buf ) != vartype("str") ) {
		sdim      buf, mStrlen + 1
	} else {
		memexpand buf, mStrlen + 1
	}
	
	repeat mCntUnits
	//	poke buf, (cnt * mUnitSize), mList(cnt)
		if ( cnt == mIdx ) {
			memcpy buf, mList(cnt), mUnitFill, (cnt * mUnitSize)
		} else {
			memcpy buf, mList(cnt), mUnitSize, (cnt * mUnitSize)
		}
	loop
	poke buf, mStrlen, 0
	return
	
//##########################################################
//        擾n
//##########################################################
//------------------------------------------------
// [i] ̒Ԃ
//------------------------------------------------
#modcfunc Rope_length
	return mStrlen
	
#define global ctype Rope_empty(%1) ( 0 != Rope_length(%1) )
#define global Rope_size  Rope_length
#define global Rope_count Rope_length

//------------------------------------------------
// mۍς݃obt@̑傫Ԃ
//------------------------------------------------
#modcfunc Rope_bufSize
	return mCntUnits * mUnitSize
	
//------------------------------------------------
// ֐`ŕԂ (񐄏)
// 
// @ ő 1024 [byte] B
//------------------------------------------------
;#modcfunc Rope_get  local buf
;	Rope_tobuf thismod, buf
;	return buf
	
//------------------------------------------------
// ϐ
//------------------------------------------------
#modcfunc local Rope_cntUnits
	return mCntUnits
	
#modcfunc local Rope_dataPtr int idx
	return varptr(mList(cnt))
	
#modcfunc local Rope_getUnitFill
	return mUnitFill
	
#modcfunc local Rope_getUnitSize
	return mUnitSize

//##########################################################
//        ֐
//##########################################################
//------------------------------------------------
// [i] 
// 
// @ mۂ͉Ȃ
//------------------------------------------------
#modfunc Rope_clear
	poke mList(0)
	mIdx      = 0
	mUnitFill = 0
	return
	
//------------------------------------------------
// [i] A
//------------------------------------------------
#modfunc Rope_chain var mv_from,  local data, local cntUnits, local len
	cntUnits = Rope_cntUnits@MCRope(mv_from)
	len = Rope_getUnitSize@MCRope(mv_from)
	repeat cntUnits
		// ŏIs mv_from.mUnitFill ̕Rs[
		if ( cnt == cntUnits - 1 ) {
			len = Rope_getUnitFill@MCRope(mv_from)
		}
		
		dupptr data, Rope_dataPtr@MCRope(mv_from, cnt), len, vartype("str")
		Rope_addv thismod, data, len
	loop
	return
	
//------------------------------------------------
// [i] 
//------------------------------------------------
#modfunc Rope_copy var mv_from
	Rope_clear thismod
	Rope_chain thismod, mv_from
	return
	
//------------------------------------------------
// [i] Rei
//------------------------------------------------
#modfunc Rope_exchange var mv2, local mvTemp
	Rope_new  mvTemp
	Rope_copy mvTemp,  thismod
	Rope_copy thismod, mv2
	Rope_copy mv2,     mvTemp
	Rope_delete mvTemp
	return
	
//##########################################################
//        \bh
//##########################################################
//------------------------------------------------
// Vjbg𐶐
// @private
//------------------------------------------------
#modfunc Rope_allocUnit@MCRope
	mIdx ++
	mUnitFill = 0
	memexpand mCurUnit, mUnitSize	// jbg̃TCYɊg
	return
	
#global

#if 0

#define Rope_print(%1) %tRope Rope_tobuf (%1), %i : mes %o

	mes "012345678901234567890123456789"
	
	Rope_new r, 4
	
	Rope_add r, "Hello, world!"			// ̘A
	Rope_add r, " This is a pen."
	Rope_print r
	
	Rope_erase_back r, 8	// 납폜
	Rope_erase_back r, 3
	Rope_print r
	
	Rope_new r2, 5
	Rope_set r2, "Second Rope."
	
	Rope_chain r, r2
	Rope_print r
	stop
	
#endif

#endif
